var loading = false;

function countDown(endtime){
	var now = new Date();
	var leftTime = endtime * 1000 - now.getTime();
	var str = '';
	if (leftTime > 0) {
		var dd = parseInt(leftTime / 1000 / 60 / 60 / 24, 10);
		var hh = parseInt(leftTime / 1000 / 60 / 60 % 24, 10);
		var mm = parseInt(leftTime / 1000 / 60 % 60, 10);
		var ss = parseInt(leftTime / 1000 % 60, 10);
		if (dd) str += '<em>'+dd+'</em>天';
		if (dd || hh) str += '<em>'+hh+'</em>时';
		if (dd || hh || mm) str += '<em>'+mm+'</em>分';
		if (dd || hh || mm || ss) str += '<em>'+ss+'</em>秒';
	}
	return str;
}

function isNumber(val) {
	var regPos = /^\d+(\.\d+)?$/; //非负浮点数
	var regNeg = /^(-(([0-9]+\.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*\.[0-9]+)|([0-9]*[1-9][0-9]*)))$/; //负浮点数
	if (regPos.test(val) || regNeg.test(val)) {
		return true;
	}else{
		return false;
	}
}

function isPhone(phone) {
	var pattern=/^13[\d]{9}$|^14[5,7]{1}\d{8}$|^15[^4]{1}\d{8}$|^17[0,3,5,6,7,8]{1}\d{8}$|^18[\d]{9}$/;
	return pattern.test(phone) ? true : false;
}

function logout() {
	loading = layer.open({type:2});
	$.get('/user/logout').then(function(data){
		$.msg(data);
	}, function(){
		$.msg({msg:'通讯错误'});
	});
}

$.msg = function(data){
	layer.close(loading);
	var time = typeof(data.time) != 'undefined' ? data.time : 1;
	var msg = {content:data.msg, skin:'msg', time:time};
	if (typeof(data.url) != 'undefined') msg['end'] = function(){
		window.location.href = data.url;
	}
	if (typeof(data.reload) != 'undefined') msg['end'] = function(){
		window.location.reload();
	}
	layer.open(msg);
}

$.notice = function(title, content){
	layer.open({
		title: [title, 'background-color:#3671a3;color:#fff'],
		content: content,
		btn: '我知道了'
	});	
}

$(function(){
	// 禁止提交空表单
	$('form:not(.enable) input').keyup(function(){
		var disabled = false;
		var form = $(this).parents('form');
		var button = form.find('button[type="submit"]');
		form.find('input').each(function(){
			if ($(this).val() == '') {
				disabled = true;
				return;
			}
		});
		disabled ? button.attr('disabled', true) : button.removeAttr('disabled');
	});

	// Ajax提交表单
	$('form.form, #login form').submit(function(){
		loading = layer.open({type:2});
		$.post(window.location.href, $(this).serialize()).then(function(data){
			$.msg(data);
		}, function(){
			$.msg({msg:'通讯错误'});
		});
		return false;
	});

	$('#login input').not('.on').focus(function(){
		$(this).prev().addClass('on');
	});
	$('#login input').blur(function(){
		if ($(this).val() == '') $(this).prev().removeClass('on');
	});
	$('#login .pwd .iconfont').click(function(){
		var input = $(this).prev('input');
		if (input.attr('type') == 'password') {
			input.attr('type', 'text');
			$(this).removeClass('icon-pwd-hide').addClass('icon-pwd-show');
		} else {
			input.attr('type', 'password');
			$(this).removeClass('icon-pwd-show').addClass('icon-pwd-hide');
		}
	});

	// 弹出层表单
	$('a.item-pop').click(function(){
		loading = layer.open({type: 2});
		$.get($(this).attr('href'), function(data){
			layer.close(loading);
			layer.open({
				type: 1,
				content: data,
				anim: 'up',
				className: 'pop-form'
			});
		});
		return false;
	});
	$(document).on('click', '.pop-form header i', function(){
		layer.closeAll();
	});
	$(document).on('submit', '.pop-form form', function(){
		loading = layer.open({type:2});
		$.post($(this).attr('action'), $(this).serialize()).then(function(data){
			$.msg(data);
		}, function(){
			$.msg({msg:'通讯错误'});
		});
		return false;
	});

	// 无限加载
	if ($('body.dropload').length) {
		var page = 0;
		$('body').dropload({
			scrollArea: window,
			loadDownFn: function(e){
				page++;
				$.post(window.location.href, {page:page}).then(function(data){
					$('.list').append(data.html);
					if (data.status == 1) {
						e.lock();
						e.noData();
						if (page == 1 && data.html == '') {
							$('.list').html('<div class="empty"><img src="/themes/default/assets/img/empty.png"></div>');
						}
					}
					e.resetload();
				}, function(){
					$.msg({msg:'通讯错误'});
					e.resetload();
				});
			}
		});
	}
});